/*
 *	File:	BrotWindow.h
 *	---------------------
 *
 *	BrotWindow is the file which creates the offscreen GWorld, the window itself,
 *	and handles the basic controls for the window.
 *
 *
 */

#ifndef	__BrotWindow__
#define __BrotWindow__

#include	"Window.h"
#include	<Threads.h>
#include 	"AppLib.h"
#include	<QDOffscreen.h>
#include 	<LowMem.h>	//	for LMGetCurApName()
#include	"QueueThreads.h"

class	BrotWindow	:	public TWindow
{
public:
		WindowPtr		me;
		Rect			osImageArea;
		GWorldPtr		osImage;
		QueueThreads	*queue;
		Point			gTopLeftP;
		Complex			gTopLeftC;
		_Float			gScale;
		
public:
						BrotWindow();
	virtual 			~BrotWindow();

	virtual WindowPtr	MakeNewWindow(WindowPtr behindWindow);

	virtual	void		AdjustCursor(EventRecord * anEvent);
	virtual void		Activate(Boolean activating);
	virtual void		Draw(void);
	virtual void		Click(EventRecord * anEvent);
	virtual	void		KeyDown(EventRecord * anEvent);

	virtual void		AdjustForNewWindowSize(Rect * oldRect,Rect * newRect);

	virtual	Boolean		Close(void);
	
	virtual	OSErr		HandleDrag(DragTrackingMessage dragMessage,DragReference theDrag);
	virtual	OSErr		HandleDrop(DragReference theDrag);
			Boolean		MakeGWorld( WindowPtr owner);

	void	ZoomIn( Point where);
	void	ZoomOut( Point where);
	void	DragMandelbrot( Point where);
	OSErr	MakeWholeWindowThread( Complex *fp, _Float pscale);
	short	IsKeyPressed(unsigned short k );

protected:

};

	void	DragIterator( ThreadBrot *thread, long refcon);

#endif
