#include "QueueThreads.h"

	QueueThreads::QueueThreads( void)
{
	gThreadQueueHead = nil;
}

	QueueThreads::~QueueThreads( void)
{
	KillAllThreads();
}



void	QueueThreads::TitleIsNumThrds( WindowPtr owner)
{
	short		numThrds;
	Str255		numStr;
	
	return;
	
	numThrds = CountQueueThreads();
	NumToString( numThrds, numStr);
	SetWTitle( owner, numStr);
}


void	QueueThreads::QueueThread( ThreadBrot *who)
{
	ThreadQueuePtr		newQ = (ThreadQueuePtr) NewPtr( sizeof( ThreadQueue));
	
	if( newQ)
	{
		newQ->prev = nil;
		newQ->next = gThreadQueueHead;
		newQ->thread = who;
		if( gThreadQueueHead)
			gThreadQueueHead->prev = newQ;
		gThreadQueueHead = newQ;
	}
}

short	QueueThreads::CountQueueThreads( void)
{
	ThreadQueuePtr		oldQ;
	short				numThrds = 0;
	
	oldQ = gThreadQueueHead;
	
	while( oldQ)
	{
		oldQ = oldQ->next;
		numThrds++;
	}

	return numThrds;
}

void	QueueThreads::DeQueueThread( ThreadBrot *who)
{
	ThreadQueuePtr		oldQ;
	
	oldQ = gThreadQueueHead;
	
	while( oldQ && oldQ->thread != who)
		oldQ = oldQ->next;
	
	if( oldQ)
	{
		if( oldQ == gThreadQueueHead)
			gThreadQueueHead = oldQ->next;

		if( oldQ->next)
			oldQ->next->prev = oldQ->prev;
		if( oldQ->prev)
			oldQ->prev->next = oldQ->next;

		DisposePtr( (Ptr) oldQ);
	}
}


void	QueueThreads::IterateOverQueues( IteratorPtr func, long refcon)
{
	IteratorHelper( HaltThreads, 0);

	IteratorHelper( func, refcon);
	
	IteratorHelper( ContinueThreads, 0);
}


void	QueueThreads::IteratorHelper( IteratorPtr func, long refcon)
{
	ThreadQueuePtr		currentQ;
	ThreadQueuePtr		nextQ;
	
	currentQ = gThreadQueueHead;
	
	while( currentQ)
	{
		nextQ = currentQ->next;
		(*func)( currentQ->thread, refcon);
		currentQ = nextQ;
	}
}

void	HaltThreads( ThreadBrot *thread, long /* refcon */)
{
	SetThreadState( thread->threadInfo, kStoppedThreadState, 0);
}


void	ContinueThreads( ThreadBrot *thread, long /* refcon */)
{
	SetThreadState( thread->threadInfo, kReadyThreadState, 0);
}

void	KillAllThreadsIterator( ThreadBrot *thread, long /* refcon */)
{
	thread->queue->DeQueueThread( thread);
	DisposeThread( thread->threadInfo, nil, true);
}

void	QueueThreads::KillAllThreads( void)
{
	IterateOverQueues( KillAllThreadsIterator, 0);
}