
#include "ThreadBrot.h"

void	ThreadBrot::TestRect( void)
{
	if( TraceEdges())
		FillRect();
	
	else
	{
		short			width = botRightP.h-topLeftP.h;
		short			height = botRightP.v-topLeftP.v;

		if( width < kMinDivideSize && height < kMinDivideSize)
			CalcRect();
		else
			if( width > height)
			{
#define	kTestNewThreadSize		64		/*	64 seemed pretty fast */
				if( width > kTestNewThreadSize)
//				if( width > kNewThreadSize)
					ThreadRight();
				else
					DoRight();
				
				DoLeft();
			}
			else
			{
				if( height > kTestNewThreadSize)
//				if( height > kNewThreadSize)
					ThreadBottom();
				else
					DoBottom();
				
				DoTop();
			}
	}
}


void	ThreadBrot::DoRight( void)
{
	Parameterics		p;
	
	SetupParameterics( &p);
	
	topLeftP.h = (topLeftP.h + botRightP.h) >> 1;
	topLeftC.real += (topLeftP.h - p.topLeftP.h) * scale;

	DrawColumn( &topLeftC, &topLeftP, botRightP.v - topLeftP.v);

	TestRect();
	
	topLeftP = p.topLeftP;
	topLeftC = p.topLeftC;
}


void	ThreadBrot::DoLeft( void)
{
	Parameterics		p;
	
	SetupParameterics( &p);
	
	botRightP.h = (topLeftP.h + botRightP.h) >> 1;

	TestRect();
	
	botRightP = p.botRightP;
}


void	ThreadBrot::DoTop( void)
{
	Parameterics		p;
	
	SetupParameterics( &p);
	
	botRightP.v = (topLeftP.v + botRightP.v) >> 1;

	TestRect();
	
	botRightP = p.botRightP;
}


void	ThreadBrot::DoBottom( void)
{
	Parameterics		p;
	
	SetupParameterics( &p);
	
	topLeftP.v = (topLeftP.v + botRightP.v) >> 1;
	topLeftC.imag -= (topLeftP.v - p.topLeftP.v) * scale;

	DrawRow( &topLeftC, &topLeftP, botRightP.h - topLeftP.h);

	TestRect();
	
	topLeftP = p.topLeftP;
	topLeftC = p.topLeftC;
}



void	ThreadBrot::ThreadRight( void)
{
	Parameterics		p;
	
	SetupParameterics( &p);
	
	p.topLeftP.h = (topLeftP.h + botRightP.h) >> 1;
	p.topLeftC.real += (p.topLeftP.h - topLeftP.h) * scale;
	
	DrawColumn( &p.topLeftC, &p.topLeftP, botRightP.v - topLeftP.v);

	p.topLeftP.h += dh;
	p.topLeftP.v += dv;
	p.botRightP.h += dh;
	p.botRightP.v += dv;
	p.frame = false;
	
	(void) new ThreadBrot( &p);
}


void	ThreadBrot::ThreadBottom( void)
{
	Parameterics		p;
	
	SetupParameterics( &p);
	
	p.topLeftP.v = (topLeftP.v + botRightP.v) >> 1;
	p.topLeftC.imag -= (p.topLeftP.v - topLeftP.v) * scale;
	
	DrawRow( &p.topLeftC, &p.topLeftP, botRightP.h - topLeftP.h);

	p.topLeftP.h += dh;
	p.topLeftP.v += dv;
	p.botRightP.h += dh;
	p.botRightP.v += dv;
	p.frame = false;

	(void) new ThreadBrot( &p);
}


void	ThreadBrot::SetupParameterics( ParametericsPtr p)
{
	p->botRightP		= botRightP;
	p->osImage 			= osImage;
	p->osImageArea	 	= osImageArea;
	p->window 			= window;
	p->queue			= queue;
	p->topLeftC 		= topLeftC;
	p->topLeftP 		= topLeftP;
	p->scale 			= scale;
	p->bitDepth 		= bitDepth;
	p->iterations 		= iterations;
	p->frame 			= false;
}
