/*
 *	File:	ThreadBrot.h
 *
 *	This file defines the ThreadBrot class.
 *
 *
 *
 */

#ifndef	__ThreadBrot__
#define __ThreadBrot__

class	ThreadBrot;

#include <QDOffscreen.h>
#include <Threads.h>
#include "QueueThreads.h"

typedef	unsigned long		ulong;
typedef	unsigned int		uint;
typedef	unsigned short		ushort;
typedef	unsigned char		uchar;
typedef	uchar				OSPixel;
typedef	OSPixel				*OSPixelPtr;
#define	kOSImageBitDepth	(sizeof( OSPixel) * 8)

#ifdef powerc
typedef double				_Float;
#else
typedef	extended			_Float;
#endif

#define	kNewPointCount		1000
#define	kYieldTime			10
#define	kMinDivideSize		5
#define	kNewThreadSize		64


struct Complex {
	_Float					real;
	_Float					imag;
};
typedef struct Complex Complex;


#define	PARAMETERICS						\
	Rect					osImageArea;	\
	Complex					topLeftC;		\
	Point					topLeftP;		\
	Point					botRightP;		\
	_Float					scale;			\
	short					bitDepth;		\
	GWorldPtr				osImage;		\
	WindowPtr				window;			\
	QueueThreads			*queue;			\
	uint					iterations;		\
	Boolean					frame;			

typedef struct {
	PARAMETERICS
} Parameterics, *ParametericsPtr;

extern long					ggLargestStack;

class	ThreadBrot {
public:
	PARAMETERICS
	ulong					brotTimer;
	ulong					newPointCount;
	Rect					bigPicture;
	PixMapHandle			osPixmap;
	long					startTime;
	OSPixelPtr				osStart, osEnd;
	ulong					osRowBytes;
	ulong					osRowPixels;
	ThreadID				threadInfo;
	OSPixelPtr				pixels;
	Rect					updateRect;
	ulong					pointCount;
	long					dh, dv;	
	Rect					threadRect;
	Complex					threadC;
	long					gMaxLengthOfStack;
	long					gTopOfStack;
public:
		ThreadBrot( ParametericsPtr p);
//		~ThreadBrot();

void	Entry( void);
OSPixelPtr	Yield( int h, int v);
void	OpenOSImage( void);
void	CloseOSImage( void);
void	OffsetThread( int offsetX, int offsetY);
void	CalculateNewPointCount( void);

OSPixelPtr	
		GeneratePixels( Point *p);
OSPixelPtr
		GeneratePixels( int h, int v);
void	UpdateRect( int h, int v);
void	UpdateRect( Point *p);

void	PlotPoint( OSPixelPtr p, long v);
OSPixelPtr	CalcBrotPoint( OSPixelPtr offscreenptr, 
					   int h, int v, Complex *c);
void	FrameBrot( void);
void	DrawColumn( Complex *topC, Point *topP, short length);
void	DrawRow( Complex *leftC, Point *leftP, short length);
void	TestRect( void);
Boolean	TraceEdges( void);
void	FillRect( void);
void	CalcRect( void);
void	ThreadBottom( void);
void	ThreadRight( void);
void	DoRight( void);
void	DoLeft( void);
void	DoTop( void);
void	DoBottom( void);
void	SetupParameterics( ParametericsPtr p);
void	MarkRect( Rect *rect);
};

pascal void	*ThreadBrotEntry( void *there);

#endif
