
#include "BrotWindow.h"
#include "ThreadBrot.h"

void
BrotWindow::Click(EventRecord *anEvent)
{
	this->Select();

	if( anEvent->modifiers & cmdKey)
		if( anEvent->modifiers & shiftKey)
			ZoomOut( anEvent->where);
		else
			ZoomIn( anEvent->where);
	else if( anEvent->modifiers & optionKey)
		DragMandelbrot( anEvent->where);
}


void	BrotWindow::ZoomOut( Point /* where */)
{
	queue->KillAllThreads();
}

void	BrotWindow::DragMandelbrot( Point where)
{
	Point			delta;
	Point			currMouse;
	Rect			start, end;
	Point			mouseStart;
	RgnHandle		tempRgn;
	PixMapHandle	osPixmap;
	
	mouseStart = where;
		
	while( Button())
	{
		GetMouse( &currMouse);
		delta.h = currMouse.h - mouseStart.h;
		delta.v = currMouse.v - mouseStart.v;

		if( !delta.h && !delta.v)
			YieldToAnyThread();
		else
		{
			start = osImageArea;
			end = osImageArea;
			OffsetRect( &end, delta.h, delta.v);

			osPixmap = GetGWorldPixMap( osImage);

			LockPixels( osPixmap);

			SetPort( (GrafPtr) osImage);

			tempRgn = NewRgn();
			
			ScrollRect( &osImageArea, delta.h, delta.v, tempRgn);
			
			DisposeRgn( tempRgn);
			
//			( (const BitMap *) (*(osImage->portPixMap)), 
//					  (const BitMap *) (*(osImage->portPixMap)),
//					  &start,&end,srcCopy,nil);

			SetPort( me);

			CopyBits( (const BitMap *) (*GetGWorldPixMap(osImage)), 
					  (const BitMap *) (*(((CWindowPtr)me)->portPixMap)),
					  &start,&start,srcCopy,nil);
	
			UnlockPixels( osPixmap);
	
			queue->IterateOverQueues( DragIterator, (long) &delta);
		}
		
		mouseStart = currMouse;
	}
}


void	DragIterator( ThreadBrot *thread, long refcon)
{
	Point		*deltaptr = (Point *)refcon;
	
	thread->OffsetThread( deltaptr->h, deltaptr->v);
}

#define		kCmdKey		0x37
#define		kShiftKey	0x38
#define		kOptKey		0x3A

void	BrotWindow::ZoomIn( Point p)
{
	Complex		old;
	_Float		enlrg;		//	Percentage of enlargement for each click
	
	queue->KillAllThreads();

	if( IsKeyPressed( kCmdKey))
		enlrg = 8;
	else
		enlrg = 2;
	
	if( IsKeyPressed( kShiftKey))
		enlrg = 1/enlrg;
	
	old.imag = -gScale * p.v + gTopLeftC.imag;
	old.real = gScale * p.h + gTopLeftC.real;
	
	gScale /= enlrg;

	gTopLeftC.imag = old.imag + gScale * p.v;
	gTopLeftC.real = old.real - gScale * p.h;

	MakeWholeWindowThread( &gTopLeftC, gScale);
}


short BrotWindow::IsKeyPressed(unsigned short k )
// k =  any keyboard scan code, 0-127
// Copyright 1991 - 1994 Symantec
// Thanks to Think Reference
{
	unsigned char km[16];

	GetKeys( (long *) km);
	return ( ( km[k>>3] >> (k & 7) ) & 1);
}


