/*
	File:		AppLib.h

	Contains:	Prototypes for the guts of a Macintosh application.

	Written by: Dave Falkenburg

	Copyright:	 1993 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):
	 
 */

#ifndef		_APPLIB_
#define		_APPLIB_

#include	<Types.h>
#include	<Windows.h>
#include	<Dialogs.h>
#include	<Menus.h>
#include	<Files.h>
#include	<AppleEvents.h>
#include	<StandardFile.h>
#include	<OCEStandardMail.h>

#include	"Window.h"

#ifndef	DEBUG
#define	DEBUG	1
#endif

#if	DEBUG
#define	DebugMessage(x)	DebugStr(x)
#else
#define	DebugMessage(x)
#endif

//	Resource IDs

#define	kErrorAlertID						128
#define	kStandardCloseAlertID				129
#define	kStandardCloseWithNewPubsAlertID	130

#define	kCoreErrorStrings					128
#define	kUnsupportedSystemSoftware			1
#define	kNeedsThreadManager					2

#define	kStandardCloseStrings				129
#define	kQuittingStr						1
#define	kClosingStr							2

#define	kPreferencesFileStrings				130
#define	kPreferencesFileName				1

//	Useful functions provided by App:

void					HandleEvent(EventRecord *anEvent);
void					HandleClose(WindowPtr aWindow);

short					StandardAlert(short alertID);

void					ErrorAlert(short stringList,short whichString);
void					FatalErrorAlert(short stringList,short whichString);

extern ModalFilterUPP	StandardDialogFilter;
extern ModalFilterYDUPP	StandardDialogFilterYD;

enum	StandardCloseResult
	{
	kSaveDocument = 1,
	kCancelSaveDocument = 2,
	kDontSaveDocument = 3
	};

StandardCloseResult		StandardCloseDocument(const StringPtr documentType,StringPtr documentName, Boolean hasNewEditions, Boolean quitting);

OSErr					CheckAppleEventForMissingParams(AppleEvent *theAppleEvent);

short					OpenPreferencesResFile(void);

//	AOCE FrontWindow-equivalent routine for the Standard Mail package
extern FrontWindowUPP	FrontWindowProcForAOCEUPP;

//	Globals

extern	Boolean		gDone;
extern	Boolean		gMenuBarNeedsUpdate;

extern	Boolean		gHasColorQuickdraw;
extern	Boolean		gHasThreadManager;
extern	Boolean		gHasDragManager;
extern	Boolean		gHasAOCE;
extern	Boolean		gHasDisplayManager;
extern	Boolean		gHasTextServices;
extern	Boolean		gHasTSMTE;

extern	GrafPtr		gWindowManagerPort;
extern	Rect		gDeskRectangle;
extern	RgnHandle	gMouseRegion;


//	Routines that the application MUST supply:

extern	OSErr	SetupApplication(void);
extern	void	HandleMenu(TWindow * topWindowObj,long menuCode);
extern	void	ConvertClipboard(void);

extern	OSErr	OpenNewDocument(void);
extern	OSErr	OpenDocument(LetterDescriptor *);
extern	OSErr	PrintDocument(LetterDescriptor *);
extern	Boolean	QuitApplication(void);

#endif
