/*
	File:		AppleEventHandling.h

	Contains:	Minimalist support for the required and Display Manager suites
				To really support AppleScript, well do more work in here.

	Written by: Dave Falkenburg

	Copyright:	 1993 by Dave Falkenburg, all rights reserved.

	Change History (most recent first):	 
 */

#ifndef		_APPLEEVENTHANDLING_
#define		_APPLEEVENTHANDLING_

#ifndef		__APPLEEVENTS__
#include	<AppleEvents.h>
#endif

#ifndef		__OCESTANDARDMAIL__
#include	<OCEStandardMail.h>
#endif

#ifndef		_APPLIB_
#include	"AppLib.h"
#endif


void			InstallAppleEventHandlers(void);

OSErr			CheckAppleEventForMissingParams(AppleEvent *theAppleEvent);


//	Handlers for the Required Suite:

typedef OSErr	(*EachDocumentProcPtr)(LetterDescriptor *aFile);

pascal OSErr	HandleOpenApplication(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);
pascal OSErr	HandleOpenOrPrintDocuments(AppleEvent *theAppleEvent,AppleEvent *reply,EachDocumentProcPtr docProc);
pascal OSErr	HandleQuitApplication(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);

//	Edition Manager:

pascal OSErr	HandleSectionRead(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);
pascal OSErr	HandleSectionWrite(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);
pascal OSErr	HandleSectionScroll(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);
pascal OSErr	HandleSectionCancel(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);


//	Display Manager:

pascal OSErr	HandleDisplayManagerNotice(AppleEvent *theAppleEvent,AppleEvent *reply,long refCon);


#endif
